%%%%%%%%%%%%                                        %%%%%%%%%%%%
%%%%%%%%%%%%   Spherical Radon Transform            %%%%%%%%%%%%
%%%%%%%%%%%%                                        %%%%%%%%%%%%

function I_Radon = Radon_circular(Im,c_theta,N_R)

N_theta = length(c_theta);
[N,N] = size(Im);
% c_x, c_y a 2D space grid of the image
c_x = linspace(-1,1,N)'*ones(1,N);
c_y=c_x';

% grid of temporal samples, up to 2 meaning information from the whole
% object.
    c_r = linspace(0,2,N_R);

I_Radon = zeros(N_theta,N_R);

px_theta =cos(c_theta);
py_theta =sin(c_theta);
%%%%%%%%%%%%%% 
 %h = waitbar(0,'Please wait...');
for i_r = 1:N_R,
     % waitbar(i_r/N_R,h)
   %%%%%%%% parametrisation du cercle 
    r = c_r(i_r);
    N_cercle = round(pi*r*N)+1;
    theta = linspace(0,2*pi*(1 - 1/(N_cercle+1)),N_cercle);
    for i_theta=1:N_theta,
      %  for i_theta=selec_theta,
       ppx_theta =  px_theta(i_theta) + r*cos(theta);
       ppy_theta =  py_theta(i_theta) + r*sin(theta);
       sum=0;
       for k=1:N_cercle,
       %if (ppx_theta(k)>-1 && ppx_theta(k)<1 && ppy_theta(k)>-1 && ppy_theta(k)<1)
      if (ppx_theta(k)^2 + ppy_theta(k)^2<0.95)
      
       indice_x = (ppx_theta(k)+1)*(N-1)/2+1;
       indice_y = (ppy_theta(k)+1)*(N-1)/2+1;
       lambda_x = indice_x -floor(indice_x);
       lambda_y = indice_y -floor(indice_y);
      %sum = sum + Im(floor(indice_x),floor(indice_y));
       sum=sum + (1-lambda_x)*(1-lambda_y)*Im(floor(indice_x),floor(indice_y)) ...
           +(lambda_x)*(1-lambda_y)*Im(min(floor(indice_x)+1,N),floor(indice_y)) ...
           +(1-lambda_x)*(lambda_y)*Im(floor(indice_x),min(floor(indice_y)+1,N)) ...
           + (lambda_x)*(lambda_y)*Im(min(floor(indice_x)+1,N),min(floor(indice_y)+1,N))     ;
       end

       end
       %I_Radon(i_theta,i_r) = 2*pi*sum/N_cercle;
       I_Radon(i_theta,i_r) = 2*pi*r*sum/N_cercle;
    end
end
%close(h);